## tdb 1.4.9

=== debian/changelog ===
tdb (1.4.9-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports (no changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 06 Oct 2023 18:24:13 +0300

tdb (1.4.9-2) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * debian/upstream/metadata: Add Repository, Repository-Browse

  [ Michael Tokarev ]
  * d/rules: wrap _PYTHON_SYSCONFIGDATA_NAME setting to cross-compile case
    On e.g. buster, _PYTHON_SYSCONFIGDATA_NAME is different, so this assignment
    does not work right.  In order for it to work on buster, add condition on
    host vs build gnu type. This breaks compilation with foreign python binary.

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 04 Aug 2023 14:23:27 +0300

tdb (1.4.9-1) unstable; urgency=medium

  * new upstream release

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 30 Jul 2023 23:12:17 +0300

## tdb 1.4.10

=== Makefile ===
# simple makefile wrapper to run waf

WAF_BIN=`PATH=buildtools/bin:../../buildtools/bin:$$PATH which waf`
WAF_BINARY=$(PYTHON) $(WAF_BIN)
WAF=PYTHONHASHSEED=1 WAF_MAKE=1 $(WAF_BINARY)

all:
	$(WAF) build

install:
	$(WAF) install

uninstall:
	$(WAF) uninstall

test: FORCE
	$(WAF) test $(TEST_OPTIONS)

testenv:
	$(WAF) test --testenv $(TEST_OPTIONS)

quicktest:
	$(WAF) test --quick $(TEST_OPTIONS)

dist:
	touch .tmplock
	WAFLOCK=.tmplock $(WAF) dist

distcheck:
	touch .tmplock
	WAFLOCK=.tmplock $(WAF) distcheck

clean:
	$(WAF) clean

distclean:
	$(WAF) distclean

reconfigure: configure
	$(WAF) reconfigure

show_waf_options:
	$(WAF) --help

# some compatibility make targets
everything: all

testsuite: all

check: test

torture: all

# this should do an install as well, once install is finished
installcheck: test

etags:
	$(WAF) etags

ctags:
	$(WAF) ctags

bin/%:: FORCE
	$(WAF) --targets=`basename $@`
FORCE:

=== buildtools/wafsamba/wscript ===
#!/usr/bin/env python

# this is a base set of waf rules that everything else pulls in first

import os, sys
from waflib import Configure, Logs, Options, Utils, Context, Errors
import wafsamba
from samba_utils import symlink
from optparse import SUPPRESS_HELP

phs = os.environ.get("PYTHONHASHSEED", None)
if phs != "1":
    raise Errors.WafError('''PYTHONHASHSEED=1 missing! Don't use waf directly, use ./configure and make!''')

# this forces configure to be re-run if any of the configure
# sections of the build scripts change. We have to check
# for this in sys.argv as options have not yet been parsed when
# we need to set this. This is off by default until some issues
# are resolved related to WAFCACHE. It will need a lot of testing
# before it is enabled by default.
if '--enable-auto-reconfigure' in sys.argv:
    Configure.autoconfig = 'clobber'

def default_value(option, default=''):
    if option in Options.options.__dict__:
        return Options.options.__dict__[option]
    return default

def options(opt):
    opt.load('compiler_cc')

    opt.load('gnu_dirs')

    gr = opt.option_group('library handling options')

    gr.add_option('--bundled-libraries',
                   help=(f'''comma separated list of bundled libraries.

{Context.g_module.APPNAME} includes copies of externally maintained
system libraries (such as popt, cmocka) as well as Samba-maintained
libraries that can be found on the system already (such as talloc,
tdb).

This option, most useful for packagers, controls if each library
should be forced to be obtained from inside Samba (bundled), forced to
be obtained from the system (bundling disabled, ensuing that
dependency errors are not silently missed) or if that choice should be
automatic (best for end users).

May include !LIBNAME to disable bundling a library.

Can be 'NONE' or 'ALL' [auto]'''),
                   action="store", dest='BUNDLED_LIBS', default='')

    gr.add_option('--private-libraries',
                   help=(f'''comma separated list of normally public libraries to build instead as private libraries.

By default {Context.g_module.APPNAME} will publish a number of public
libraries for use by other software.  For Samba this would include
libwbclient, libsmbclient and others.

This allows that to be disabled, to ensure that other software does
not use these libraries and they are placed in a private filesystem
prefix.

May include !LIBNAME to disable making a library private in order to
limit the effect of 'ALL' '''),
                   action="store", dest='PRIVATE_LIBS', default='')

    extension_default = default_value('PRIVATE_EXTENSION_DEFAULT')
    gr.add_option('--private-library-extension',
                   help=("name extension for private libraries [%s]" % extension_default),
                   action="store", dest='PRIVATE_EXTENSION', default=extension_default)

    extension_exception = default_value('PRIVATE_EXTENSION_EXCEPTION')
    gr.add_option('--private-extension-exception',
                   help=("comma separated list of libraries to not apply extension to [%s]" % extension_exception),
                   action="store", dest='PRIVATE_EXTENSION_EXCEPTION', default=extension_exception)

    builtin_default = default_value('BUILTIN_LIBRARIES_DEFAULT')
    gr.add_option('--builtin-libraries', help=(
f'''comma separated list of libraries to build directly into binaries.

By default {Context.g_module.APPNAME} will build a large number of
shared libraries, to reduce binary size.  This overrides this
behaviour and essentially statically links the specified libraries into
each binary [{builtin_default}]'''),
                  action="store",
                  dest='BUILTIN_LIBRARIES', default=builtin_default)

    gr.add_option('--minimum-library-version',
                   help=(
f'''list of minimum system library versions for otherwise bundled
libraries.

{Context.g_module.APPNAME} by default requires that, in order to match
what is tested in our continuous integration (CI) test-suite, that the
versions of libraries that we include match that found on the system,
before we will select not to 'bundle'.

This option, possibly useful for packagers, allows that specified
version to be overridden (say, if it is absolutely known that the
newer version included in this tarball has no relevant changes).

Use this with extreme care

(LIBNAME1:version,LIBNAME2:version)'''),
                   action="store", dest='MINIMUM_LIBRARY_VERSION', default='')

    gr.add_option('--disable-rpath',
                   help=("Disable use of rpath for build binaries"),
                   action="store_true", dest='disable_rpath_build', default=False)
    gr.add_option('--disable-rpath-install',
                   help=("Disable use of rpath for library path in installed files"),
                   action="store_true", dest='disable_rpath_install', default=False)
    gr.add_option('--disable-rpath-private-install',
                   help=("Disable use of rpath for private library path in installed files"),
                   action="store_true", dest='disable_rpath_private_install', default=False)
    gr.add_option('--nonshared-binary',
                   help=(
f'''Disable use of shared libraries internal to {Context.g_module.APPNAME} for the listed binaries.

The resulting binaries are 'statically linked' with regard to components provided by
{Context.g_module.APPNAME}, but remain dynamically linked to (eg) libc.so and libgnutls.so

Currently the only tested value is 'smbtorture,smbd/smbd' for Samba'''),
                   action="store", dest='NONSHARED_BINARIES', default='')
    gr.add_option('--disable-symbol-versions',
                   help=("Disable use of the --version-script linker option"),
                   action="store_true", dest='disable_symbol_versions', default=False)

    opt.add_option('--with-modulesdir',
                   help=("modules directory [PREFIX/modules]"),
                   action="store", dest='MODULESDIR', default='${PREFIX}/modules')

    opt.add_option('--with-privatelibdir',
                   help=("private library directory [PREFIX/lib/%s]" % Context.g_module.APPNAME),
                   action="store", dest='PRIVATELIBDIR', default=None)

    opt.add_option('--with-libiconv',
                   help='additional directory to search for libiconv',
                   action='store', dest='iconv_open', default='/usr/local',
                   match = ['Checking for library iconv', 'Checking for iconv_open', 'Checking for header iconv.h'])
    opt.add_option('--without-gettext',
                   help=("Disable use of gettext"),
                   action="store_true", dest='disable_gettext', default=False)

    gr = opt.option_group('developer options')

    gr.add_option('-C',
                   help='enable configure caching',
                   action='store_true', dest='enable_configure_cache')
    gr.add_option('--enable-auto-reconfigure',
                   help='enable automatic reconfigure on build',
                   action='store_true', dest='enable_auto_reconfigure')
    gr.add_option('--enable-debug',
                   help=("Turn on debugging symbols"),
                   action="store_true", dest='debug', default=False)
    gr.add_option('--enable-developer',
                   help=("Turn on developer warnings and debugging"),
                   action="store_true", dest='developer', default=False)
    gr.add_option('--pidl-developer',
                   help=("annotate PIDL-generated code for developers"),
                   action="store_true", dest='pidl_developer', default=False)
    gr.add_option('--disable-warnings-as-errors',
                   help=("Do not treat all warnings as errors (disable -Werror)"),
                   action="store_true", dest='disable_warnings_as_errors', default=False)
    opt.add_option('--enable-coverage',
                   help=("enable options necessary for code coverage "
                         "reporting on selftest (default=no)"),
                   action="store_true", dest='enable_coverage', default=False)
    gr.add_option('--fatal-errors',
                   help=("Stop compilation on first error (enable -Wfatal-errors)"),
                   action="store_true", dest='fatal_errors', default=False)
    gr.add_option('--enable-gccdeps',
                   help=("Enable use of gcc -MD dependency module"),
                   action="store_true", dest='enable_gccdeps', default=True)
    gr.add_option('--pedantic',
		   help=("Enable even more compiler warnings"),
		   action='store_true', dest='pedantic', default=False)
    gr.add_option('--git-local-changes',
		   help=("mark version with + if local git changes"),
		   action='store_true', dest='GIT_LOCAL_CHANGES', default=False)
    gr.add_option('--address-sanitizer',
                   help=("Enable address sanitizer compile and linker flags"),
                   action="store_true", dest='address_sanitizer', default=False)
    gr.add_option('--undefined-sanitizer',
        help=("Enable undefined behaviour sanitizer compile and linker flags"),
        action="store_true",
        dest='undefined_sanitizer',
        default=False)
    gr.add_option('--memory-sanitizer',
        help=("Enable memory behaviour sanitizer compile and linker flags"),
        action="store_true",
        dest='memory_sanitizer',
        default=False)
    gr.add_option('--enable-libfuzzer',
                  help=("Build fuzzing binaries (use ADDITIONAL_CFLAGS to specify compiler options for libFuzzer or use CC=honggfuzz/hfuzz-cc)"),
                  action="store_true", dest='enable_libfuzzer', default=False)
    gr.add_option('--enable-afl-fuzzer',
                  help=("Build fuzzing binaries AFL-style (typically use with CC=afl-gcc)"),
                  action="store_true", dest='enable_afl_fuzzer', default=False)

    # Fuzz targets may need additional LDFLAGS that we can't use on
    # internal binaries like asn1_compile

    gr.add_option('--fuzz-target-ldflags',
                  help=("Linker flags to be used when building fuzz targets"),
                  action="store", dest='FUZZ_TARGET_LDFLAGS', default='')

    gr.add_option('--abi-check',
		   help=("Check ABI signatures for libraries"),
		   action='store_true', dest='ABI_CHECK', default=False)
    gr.add_option('--abi-check-disable',
		   help=("Disable ABI checking (used with --enable-developer)"),
		   action='store_true', dest='ABI_CHECK_DISABLE', default=False)
    gr.add_option('--abi-update',
		   help=("Update ABI signature files for libraries"),
		   action='store_true', dest='ABI_UPDATE', default=False)

    gr.add_option('--show-deps',
		   help=("Show dependency tree for the given target"),
		   dest='SHOWDEPS', default='')

    gr.add_option('--symbol-check',
                  help=("check symbols in object files against project rules"),
                  action='store_true', dest='SYMBOLCHECK', default=False)

    gr.add_option('--dup-symbol-check',
                  help=("check for duplicate symbols in object files and system libs (must be configured with --enable-developer)"),
                  action='store_true', dest='DUP_SYMBOLCHECK', default=False)

    gr.add_option('--why-needed',
                  help=("TARGET:DEPENDENCY check why TARGET needs DEPENDENCY"),
                  action='store', type='str', dest='WHYNEEDED', default=None)

    gr.add_option('--show-duplicates',
                  help=("Show objects which are included in multiple binaries or libraries"),
                  action='store_true', dest='SHOW_DUPLICATES', default=False)

    gr = opt.add_option_group('cross compilation options')

    gr.add_option('--cross-compile',
		   help=("configure for cross-compilation"),
		   action='store_true', dest='CROSS_COMPILE', default=False)
    gr.add_option('--cross-execute',
		   help=("command prefix to use for cross-execution in configure"),
		   action='store', dest='CROSS_EXECUTE', default='')

=== lib/replace/wscript ===
#!/usr/bin/env python

APPNAME = 'libreplace'
VERSION = '1.2.1'

import sys
import os

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

import wafsamba
from wafsamba import samba_dist
from waflib import Options, Utils, Logs, Context

samba_dist.DIST_DIRS('lib/replace buildtools:buildtools third_party/waf:third_party/waf')

def options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.PRIVATE_EXTENSION_DEFAULT('')
    opt.RECURSE('buildtools/wafsamba')

@Utils.run_once
def configure(conf):
    conf.RECURSE('buildtools/wafsamba')

    conf.env.standalone_replace = conf.IN_LAUNCH_DIR()

    if sys.platform.rfind('linux') > -1:
        conf.DEFINE('LINUX', '1')

    conf.DEFINE('BOOL_DEFINED', 1)
    conf.DEFINE('HAVE_LIBREPLACE', 1)
    conf.DEFINE('LIBREPLACE_NETWORK_CHECKS', 1)

    conf.CHECK_HEADERS('linux/types.h crypt.h locale.h acl/libacl.h compat.h')
    conf.CHECK_HEADERS('acl/libacl.h attr/xattr.h compat.h ctype.h dustat.h')
    conf.CHECK_HEADERS('fcntl.h fnmatch.h glob.h history.h krb5.h langinfo.h')
    conf.CHECK_HEADERS('locale.h ndir.h pwd.h')
    conf.CHECK_HEADERS('shadow.h sys/acl.h')
    conf.CHECK_HEADERS('sys/attributes.h attr/attributes.h sys/capability.h sys/dir.h sys/epoll.h')
    conf.CHECK_HEADERS('sys/fcntl.h sys/filio.h sys/filsys.h sys/fs/s5param.h')
    conf.CHECK_HEADERS('sys/id.h sys/ioctl.h sys/ipc.h sys/mman.h sys/mode.h sys/ndir.h sys/priv.h')
    conf.CHECK_HEADERS('sys/resource.h sys/security.h sys/shm.h sys/statfs.h sys/statvfs.h sys/termio.h')
    conf.CHECK_HEADERS('sys/vfs.h sys/xattr.h termio.h termios.h sys/file.h')
    conf.CHECK_HEADERS('sys/ucontext.h sys/wait.h sys/stat.h')

    if not conf.CHECK_DECLS('malloc', headers='stdlib.h'):
        conf.CHECK_HEADERS('malloc.h')

    conf.CHECK_HEADERS('grp.h')
    conf.CHECK_HEADERS('sys/select.h setjmp.h utime.h sys/syslog.h syslog.h')
    conf.CHECK_HEADERS('stdarg.h vararg.h sys/mount.h mntent.h')
    conf.CHECK_HEADERS('stropts.h unix.h string.h strings.h sys/param.h limits.h')
    conf.CHECK_HEADERS('''sys/socket.h netinet/in.h netdb.h arpa/inet.h netinet/in_systm.h
                          netinet/ip.h netinet/tcp.h netinet/in_ip.h
                          sys/sockio.h sys/un.h''', together=True)
    conf.CHECK_HEADERS('sys/uio.h ifaddrs.h direct.h dirent.h')
    conf.CHECK_HEADERS('windows.h winsock2.h ws2tcpip.h')
    conf.CHECK_HEADERS('errno.h')
    conf.CHECK_HEADERS('getopt.h iconv.h')
    conf.CHECK_HEADERS('memory.h nss.h sasl/sasl.h')
    conf.CHECK_HEADERS('linux/openat2.h')

    conf.CHECK_FUNCS_IN('inotify_init', 'inotify', checklibc=True,
                        headers='sys/inotify.h')

    conf.CHECK_HEADERS('security/pam_appl.h zlib.h asm/unistd.h')
    conf.CHECK_HEADERS('sys/unistd.h alloca.h float.h')

    conf.SET_TARGET_TYPE('tirpc', 'EMPTY')

    if conf.CHECK_CODE(
            '\n#ifndef _TIRPC_RPC_H\n#error "no tirpc headers in system path"\n#endif\n',
            'HAVE_RPC_RPC_HEADERS',
            headers=['rpc/rpc.h', 'rpc/nettype.h'],
            msg='Checking for tirpc rpc headers in default system path'):
        if conf.CONFIG_SET('HAVE_RPC_RPC_H'):
            conf.undefine('HAVE_RPC_RPC_H')

    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
        if conf.CHECK_CFG(package='libtirpc', args='--cflags --libs',
                       msg='Checking for libtirpc headers',
                       uselib_store='TIRPC'):
            conf.CHECK_HEADERS('rpc/rpc.h rpc/nettype.h', lib='tirpc', together=True)
            conf.SET_TARGET_TYPE('tirpc', 'SYSLIB')
    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
        if conf.CHECK_CFG(package='libntirpc', args='--cflags',
                       msg='Checking for libntirpc headers',
                       uselib_store='TIRPC'):
            conf.CHECK_HEADERS('rpc/rpc.h rpc/nettype.h', lib='tirpc', together=True)
            conf.SET_TARGET_TYPE('tirpc', 'SYSLIB')
    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
            Logs.warn('No rpc/rpc.h header found, tirpc or libntirpc missing?')

    # This file is decprecated with glibc >= 2.30 so we need to check if it
    # includes a deprecation warning:
    # #warning "The <sys/sysctl.h> header is deprecated and will be removed."
    conf.CHECK_CODE('''
                    #include <sys/sysctl.h>
                    int main(void) { return 0; }
                    ''',
                    define='HAVE_SYS_SYSCTL_H',
                    cflags=['-Werror=cpp'],
                    addmain=False,
                    msg='Checking for header sys/sysctl.h')

    conf.CHECK_HEADERS('sys/fileio.h sys/filesys.h sys/dustat.h sys/sysmacros.h')
    conf.CHECK_HEADERS('xfs/libxfs.h netgroup.h')

    conf.CHECK_HEADERS('valgrind.h valgrind/valgrind.h')
    conf.CHECK_HEADERS('valgrind/memcheck.h valgrind/helgrind.h valgrind/callgrind.h')
    conf.CHECK_HEADERS('nss_common.h nsswitch.h ns_api.h')
    conf.CHECK_HEADERS('sys/extattr.h sys/ea.h sys/proplist.h sys/cdefs.h')
    conf.CHECK_HEADERS('utmp.h utmpx.h lastlog.h')
    conf.CHECK_HEADERS('syscall.h sys/syscall.h inttypes.h')
    conf.CHECK_HEADERS('sys/atomic.h stdatomic.h')
    conf.CHECK_HEADERS('libgen.h')

    if conf.CHECK_CFLAGS('-Wno-format-truncation'):
        conf.define('HAVE_WNO_FORMAT_TRUNCATION', '1')

    if conf.CHECK_CFLAGS('-Wno-unused-function'):
        conf.define('HAVE_WNO_UNUSED_FUNCTION', '1')

    if conf.CHECK_CFLAGS('-Wno-strict-overflow'):
        conf.define('HAVE_WNO_STRICT_OVERFLOW', '1')

    if conf.CHECK_CFLAGS('-Wno-unused-but-set-variable'):
        conf.define('HAVE_WNO_UNUSED_BUT_SET_VARIABLE', '1')

    if conf.CHECK_CFLAGS('-Wuse-after-free=1'):
        conf.define('HAVE_WUSE_AFTER_FREE_1', '1')

    # Check for process set name support
    conf.CHECK_CODE('''
                    #include <sys/prctl.h>
                    int main(void) {
                        prctl(0);
                        return 0;
                    }
                    ''',
                    'HAVE_PRCTL',
                    addmain=False,
                    headers='sys/prctl.h',
                    msg='Checking for prctl syscall')

    conf.CHECK_CODE('''
                    #include <unistd.h>
                    #ifdef HAVE_FCNTL_H
                    #include <fcntl.h>
                    #endif
                    int main(void) { int fd = open("/dev/null", O_DIRECT); }
                    ''',
                    define='HAVE_OPEN_O_DIRECT',
                    addmain=False,
                    msg='Checking for O_DIRECT flag to open(2)')

    conf.CHECK_TYPES('"long long" intptr_t uintptr_t ptrdiff_t comparison_fn_t')
    if not conf.CHECK_TYPE('bool', define='HAVE_BOOL', headers='stdbool.h'):
            raise Errors.WafError('Samba requires a genuine boolean type')

    conf.CHECK_TYPE('int8_t', 'char')
    conf.CHECK_TYPE('uint8_t', 'unsigned char')
    conf.CHECK_TYPE('int16_t', 'short')
    conf.CHECK_TYPE('uint16_t', 'unsigned short')
    conf.CHECK_TYPE('int32_t', 'int')
    conf.CHECK_TYPE('uint32_t', 'unsigned')
    conf.CHECK_TYPE('int64_t', 'long long')
    conf.CHECK_TYPE('uint64_t', 'unsigned long long')
    conf.CHECK_TYPE('size_t', 'unsigned int')
    conf.CHECK_TYPE('ssize_t', 'int')
    conf.CHECK_TYPE('ino_t', 'unsigned')
    conf.CHECK_TYPE('loff_t', 'off_t')
    conf.CHECK_TYPE('offset_t', 'loff_t')
    conf.CHECK_TYPE('volatile int', define='HAVE_VOLATILE')
    conf.CHECK_TYPE('uint_t', 'unsigned int')
    conf.CHECK_TYPE('blksize_t', 'long', headers='sys/types.h sys/stat.h unistd.h')
    conf.CHECK_TYPE('blkcnt_t', 'long', headers='sys/types.h sys/stat.h unistd.h')

    conf.CHECK_SIZEOF('bool char int "long long" long short size_t ssize_t')
    sizeof_int = conf.env["SIZEOF_INT"]
    if sizeof_int < 4:
        conf.fatal(f"Samba won't work with int of size {sizeof_int} (requires >= 4)")

    conf.CHECK_SIZEOF('int8_t uint8_t int16_t uint16_t int32_t uint32_t int64_t uint64_t')
    conf.CHECK_SIZEOF('void*', define='SIZEOF_VOID_P')
    conf.CHECK_SIZEOF('off_t dev_t ino_t time_t')

    conf.CHECK_TYPES('socklen_t', headers='sys/socket.h')
    conf.CHECK_TYPE_IN('struct ifaddrs', 'ifaddrs.h')
    conf.CHECK_TYPE_IN('struct addrinfo', 'netdb.h')
    conf.CHECK_TYPE_IN('struct sockaddr', 'sys/socket.h')
    conf.CHECK_CODE('struct sockaddr_in6 x', define='HAVE_STRUCT_SOCKADDR_IN6',
                    headers='sys/socket.h netdb.h netinet/in.h')
    conf.CHECK_TYPE_IN('struct sockaddr_storage', 'sys/socket.h')
    conf.CHECK_TYPE_IN('sa_family_t', 'sys/socket.h')

    conf.CHECK_TYPE_IN('sig_atomic_t', 'signal.h', define='HAVE_SIG_ATOMIC_T_TYPE')
    conf.CHECK_FUNCS('sigsetmask siggetmask sigprocmask sigblock sigaction sigset')

    # Those functions are normally available in libc
    if not conf.CHECK_FUNCS('''
                            inet_ntoa
                            inet_aton
                            inet_ntop
                            inet_pton
                            connect
                            gethostbyname
                            getaddrinfo
                            getnameinfo
                            freeaddrinfo
                            gai_strerror
                            socketpair''',
                            headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h'):
        conf.CHECK_FUNCS_IN('''
                            inet_ntoa
                            inet_aton
                            inet_ntop
                            inet_pton
                            connect
                            gethostbyname
                            getaddrinfo
                            getnameinfo
                            freeaddrinfo
                            gai_strerror
                            socketpair''',
                            'socket nsl',
                            headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h')
        conf.DEFINE('REPLACE_REQUIRES_LIBSOCKET_LIBNSL', 1)

    conf.CHECK_FUNCS('memset_s memset_explicit')

    conf.CHECK_CODE('''
                    #include <string.h>

                    int main(void)
                    {
                        char buf[] = "This is some content";
                        memset(buf, '\0', sizeof(buf)); __asm__ volatile("" : : "g"(&buf) : "memory");
                        return 0;
                    }
                    ''',
                    define='HAVE_GCC_VOLATILE_MEMORY_PROTECTION',
                    addmain=False,
                    msg='Checking for volatile memory protection',
                    local_include=False)

    # Some old Linux systems have broken header files and
    # miss the IPV6_V6ONLY define in netinet/in.h,
    # but have it in linux/in6.h.
    # We can't include both files so we just check if the value
    # if defined and do the replacement in system/network.h
    if not conf.CHECK_VARIABLE('IPV6_V6ONLY',
                               headers='sys/socket.h netdb.h netinet/in.h'):
        conf.CHECK_CODE('''
                        #include <linux/in6.h>
                        #if (IPV6_V6ONLY != 26)
                        #error no IPV6_V6ONLY support on linux
                        #endif
                        int main(void) { return IPV6_V6ONLY; }
                        ''',
                        define='HAVE_LINUX_IPV6_V6ONLY_26',
                        addmain=False,
                        msg='Checking for IPV6_V6ONLY in linux/in6.h',
                        local_include=False)

    conf.CHECK_CODE('''
                       struct sockaddr_storage sa_store;
                       struct addrinfo *ai = NULL;
                       struct in6_addr in6addr;
                       int idx = if_nametoindex("iface1");
                       int s = socket(AF_INET6, SOCK_STREAM, 0);

=== debian/changelog ===
tdb (1.4.10-1build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:20:50 +0200

tdb (1.4.10-1) unstable; urgency=medium

  * new upstream (minor) release

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 29 Jan 2024 20:10:24 +0300

=== debian/control ===
Source: tdb
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
           Mathieu Parent <sathieu@debian.org>,
           Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               docbook-xml, docbook-xsl, xsltproc,
# use {python3,libpython3}-ALL-dev to build for all python3 versions (+#904999):
               python3-dev:any | python3-dev, libpython3-dev,
# host python is needed for selftests
               python3 <!nocheck>,
Rules-Requires-Root: no
Homepage: https://tdb.samba.org/
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/samba-team/tdb
Vcs-Git: https://salsa.debian.org/samba-team/tdb.git

Package: libtdb1
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Trivial Database - shared library
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 This package contains the shared library file.

Package: tdb-tools
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Trivial Database - bundled binaries
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 This package contains bundled test and utility binaries

Package: libtdb-dev
Multi-Arch: same
Provides: tdb-dev
Section: libdevel
Architecture: any
Depends: libc6-dev, libtdb1 (= ${binary:Version}), ${misc:Depends}
Description: Trivial Database - development files
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 This package contains the development files.

Package: python3-tdb
Section: python
Architecture: any
Depends: libtdb1 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python3 bindings for TDB
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 This package contains the Python3 bindings.

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -g -Wall
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# Fast version of dpkg/architecture.mk defining all vars in one go
ifeq (${DEB_HOST_MULTIARCH},)
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif
include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk
V := $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)
WAF := PYTHONHASHSEED=1 ./buildtools/bin/waf \
	$(patsubst parallel=%,-j%,$(filter parallel=%,${DEB_BUILD_OPTIONS}))

ifeq (linux,${DEB_HOST_ARCH_OS})
ifneq (${DEB_HOST_GNU_TYPE},${DEB_BUILD_GNU_TYPE})
# for cross-build or build with foreign python binary (it is _gnu0_i386-gnu on hurd)
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__${DEB_HOST_ARCH_OS}_${DEB_HOST_MULTIARCH}
endif
endif

# All supported installed python versions we build for
export PY3VERSIONS := $(or ${PY3VERSIONS}, $(shell py3versions -i))

DESTDIR := ${CURDIR}/debian/tmp

build-arch build-indep build \
install-arch install-indep install \
binary-arch binary-indep binary \
: %:
	dh $@

# Build in bld/pyNN/ subdirs (named after python version),
# Since wafsamba can't build things in a named subdir,
# we have to copy (link) whole source dir into each build subdir.

.NOTPARALLEL: # don't run commands at this level in parallel

py-targets = $(patsubst %, bld/%/$(strip $1), ${PY3VERSIONS})

override_dh_auto_configure: $(call py-targets, stamp-config)
$(call py-targets, stamp-config): %/stamp-config:
	@echo "=== running configure in $* ==="
	mkdir -p $*
	cp -al $$(ls -1 | egrep -v '^(bld|debian)$$') $*
	cd $*; \
	    CC="${CC}" CPP="${CPP}" LD="${LD}" PKGCONFIG="${PKG_CONFIG}" \
	    CPPFLAGS="${CPPFLAGS}" CFLAGS="${CFLAGS}" LDFLAGS="${LDFLAGS}" \
	    PYTHON=$(notdir $*) PYTHON_CONFIG=${DEB_HOST_MULTIARCH}-$(notdir $*)-config \
	    ${WAF} -j1 -C configure \
		--prefix=/usr \
		--libdir=/usr/lib/${DEB_HOST_MULTIARCH} \
		--disable-rpath --disable-rpath-install \
		--bundled-libraries=NONE \

	touch $@

override_dh_auto_build: $(call py-targets, stamp-build)
$(call py-targets, stamp-build): %/stamp-build: %/stamp-config
	@echo "=== running build in $* ==="
	cd $*; ${WAF} $(if $V,-v) build
	# Waf should be doing this..
	ar cr $*/bin/libtdb.a $*/bin/default/common/*.o

# the testsuite does not test python bindings so there's no reason to test all pyversions
override_dh_auto_test: \
  $(if $(filter nocheck,${DEB_BUILD_OPTIONS}), , $(firstword $(call py-targets, test)))
$(call py-targets, test): %/test: %/stamp-build
	@echo "=== running test in $* ==="
	cd $*; ${WAF} test

$(call py-targets, install): %/install: %/stamp-build
	@echo "=== running install in $* ==="
	cd $*; ${WAF} install --destdir=${DESTDIR}
	cp $*/bin/libtdb.a ${DESTDIR}/usr/lib/${DEB_HOST_MULTIARCH}/
override_dh_auto_install: $(call py-targets, install)
	mv ${DESTDIR}/usr/bin/tdbbackup \
		${DESTDIR}/usr/bin/tdbbackup.tdbtools
	mv ${DESTDIR}/usr/share/man/man8/tdbbackup.8 \
		${DESTDIR}/usr/share/man/man8/tdbbackup.tdbtools.8
	#HACK alert: fix up wrong markers in the common include file
	sed -i 's/^_PUBLIC_ //' ${DESTDIR}/usr/include/tdb.h
	# ..and remove the #define itself
	patch --batch ${DESTDIR}/usr/include/tdb.h debian/header-remove-_PUBLIC_-define.patch

clean:
	dh_clean bld/

get-packaged-orig-source:
	./debian/build-orig.sh

=== debian/tests/control ===
Tests: python3-testsuite
Depends: python3-tdb, python3
Restrictions: allow-stderr

## tdb 1.4.12

=== debian/changelog ===
tdb (1.4.12-1) unstable; urgency=medium

  * New upstream version 1.4.12
  * d/libtdb1.symbols: add new version
    (and remove mistaken version form from previous upload)
  * d/control: bump Standards-Version to 4.7.0
    (no changes needed)

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 14 Aug 2024 12:40:04 +0300

tdb (1.4.11-2) unstable; urgency=medium

  * d/libtdb1.symbols: add the forgotten new version marker

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 30 Jul 2024 11:55:59 +0300

tdb (1.4.11-1) unstable; urgency=medium

  * New upstream version 1.4.11
  * d/libtdb1.symbols: use #PACKAGE# placeholder

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 30 Jul 2024 11:49:50 +0300

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: tdb
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
+Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
 Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
            Mathieu Parent <sathieu@debian.org>,
            Michael Tokarev <mjt@tls.msk.ru>
@@ -15,7 +14,7 @@
                python3 <!nocheck>,
 Rules-Requires-Root: no
 Homepage: https://tdb.samba.org/
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/samba-team/tdb
 Vcs-Git: https://salsa.debian.org/samba-team/tdb.git

## tdb 2.7.7-1uk1

=== debian/changelog ===
tdb (2.7.7-1uk1) unstable; urgency=low

  * amd64 rebuild

 -- Albrecht Gebhardt <albrecht.gebhardt@uni-klu.ac.at>  Tue, 22 May 2012 06:22:11 +0000

tdb (2.7.7-1uk) unstable; urgency=low

  * initial package

 -- Albrecht Gebhardt <albrecht.gebhardt@uni-klu.ac.at>  Sun, 12 Jul 2009 21:21:39 +0000

=== debian/control ===
Source: tdb
Section: math
Priority: extra
Maintainer: Albrecht Gebhardt <agebhard@pc30-math>

Package: tdb
Architecture: amd64
Depends: ${shlibs:Depends}
Description: Trust Desk Basic
 Trust Desk Basic client for Austrian Buergercard

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for alien

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Use v4 compatability mode, so ldconfig gets added to maint scripts.
export DH_COMPAT=4

PACKAGE=$(shell dh_listpackages)

build:
	dh_testdir

clean:
	dh_testdir
	dh_testroot
	dh_clean -d

binary-indep: build

binary-arch: build
	dh_testdir
	dh_testroot
	dh_clean -k -d
	dh_installdirs

	dh_installdocs
	dh_installchangelogs

# Copy the packages's files.
	find . -maxdepth 1 -mindepth 1 -not -name debian -print0 | \
		xargs -0 -r -i cp -a {} debian/$(PACKAGE)

#
# If you need to move files around in debian/$(PACKAGE) or do some
# binary patching, do it here
#


# This has been known to break on some wacky binaries.
#	dh_strip
	dh_compress
#	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	-dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary
